org.codehaus.groovy.tools

## Class ErrorReporter

- java.lang.Object
- - org.codehaus.groovy.tools.ErrorReporter

-     public class ErrorReporter
      extends java.lang.Object

  Provides services for reporting compilation errors to the user. Primary entry point is `write()`.

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `ErrorReporter(java.lang.Throwable e)` Configures a new Reporter.
    `ErrorReporter(java.lang.Throwable e, boolean debug)` Configures a new Reporter.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected void` | `dispatch(java.lang.Throwable object, boolean child)` Runs the report once all initialization is complete.
    `protected void` | `println(java.lang.String line)` Prints a line to the underlying `PrintStream`
    `protected void` | `println(java.lang.StringBuffer line)`
    `protected void` | `report(CompilationFailedException e, boolean child)` For CompilationFailedException.
    `protected void` | `report(java.lang.Exception e, boolean child)` For Exception.
    `protected void` | `report(GroovyExceptionInterface e, boolean child)` For GroovyException.
    `protected void` | `report(java.lang.Throwable e, boolean child)` For everything else.
    `protected void` | `stacktrace(java.lang.Throwable e, boolean always)` Displays an exception's stack trace, if `debug` or `always`.
    `void` | `write(java.io.PrintStream stream)` Writes the error to the specified `PrintStream`.
    `void` | `write(java.io.PrintWriter writer)` Writes the error to the specified `PrintWriter`.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### ErrorReporter

          public ErrorReporter(java.lang.Throwable e)

      Configures a new Reporter. Default mode is not to report a stack trace unless the error was not of one of the supported types.
      Parameters:
        `e` - the exception on which to report

    - #### ErrorReporter

          public ErrorReporter(java.lang.Throwable e,
                       boolean debug)

      Configures a new Reporter.
      Parameters:
        `e` - the exception on which to report
        `debug` - if set, stack traces will be output for all reports

  - ### Method Detail

    - #### write

          public void write(java.io.PrintStream stream)

      Writes the error to the specified `PrintStream`.

    - #### write

          public void write(java.io.PrintWriter writer)

      Writes the error to the specified `PrintWriter`.

    - #### dispatch

          protected void dispatch(java.lang.Throwable object,
                      boolean child)

      Runs the report once all initialization is complete.

    - #### report

          protected void report(CompilationFailedException e,
                    boolean child)

      For CompilationFailedException.

    - #### report

          protected void report(GroovyExceptionInterface e,
                    boolean child)

      For GroovyException.

    - #### report

          protected void report(java.lang.Exception e,
                    boolean child)

      For Exception.

    - #### report

          protected void report(java.lang.Throwable e,
                    boolean child)

      For everything else.

    - #### println

          protected void println(java.lang.String line)

      Prints a line to the underlying `PrintStream`

    - #### println

          protected void println(java.lang.StringBuffer line)

    - #### stacktrace

          protected void stacktrace(java.lang.Throwable e,
                        boolean always)

      Displays an exception's stack trace, if `debug` or `always`.